diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatterEmberAsh.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatterEmberAsh.java
new file mode 100644
index 000000000..aa2c32080
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherScatterEmberAsh.java
@@ -0,0 +1,74 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public final class WorldFeatureNetherScatterEmberAsh extends WorldFeatureNetherScatter {
+    private static final int EMBER_FIRST_ROLL_SIDES = 4;
+    private static final int EMBER_FIRST_ROLL_THRESHOLD = 1;
+
+    private final @NotNull TilePos scratchEmberProbe = new TilePos();
+    private final @NotNull TilePos scratchEmberAbove = new TilePos();
+    private final @NotNull TilePos scratchEmberNeighbor = new TilePos();
+
+    @Override
+    public boolean place(final @NotNull World world, final @NotNull Random random, final @NotNull TilePosc tilePos) {
+        if (random.nextInt(EMBER_FIRST_ROLL_SIDES) < EMBER_FIRST_ROLL_THRESHOLD) {
+            return false;
+        }
+        return this.tryEmberAsh(world, tilePos);
+    }
+
+    private boolean tryEmberAsh(final @NotNull World world, final @NotNull TilePosc start) {
+        final int x = start.x();
+        final int z = start.z();
+
+        int scanned = 0;
+        for (int y = start.y(); y > 0 && scanned < MAX_DOWN_SCAN; y--, scanned++) {
+            this.scratchEmberProbe.set(x, y, z);
+
+            if (world.getBlockType(this.scratchEmberProbe) != Blocks.BLOCK_ASH) {
+                continue;
+            }
+
+            this.scratchEmberAbove.set(x, y + 1, z);
+            if (!world.isAirBlock(this.scratchEmberAbove)) {
+                continue;
+            }
+
+            if (!isOldWorldBiome(world.getBlockBiome(this.scratchEmberProbe))) {
+                continue;
+            }
+
+            if (!isAshSurroundedByAsh(world, x, y, z)) {
+                continue;
+            }
+
+            world.setBlockType(this.scratchEmberProbe, Blocks.EMBER);
+            if (Blocks.LAYER_ASH.canPlaceAt(world, this.scratchEmberAbove)) {
+                world.setBlockType(this.scratchEmberAbove, Blocks.LAYER_ASH);
+            }
+            return true;
+        }
+        return false;
+    }
+
+    private static boolean isOldWorldBiome(final @Nullable Biome biome) {
+        return biome == Biomes.NETHER_OLD_WORLD || biome == Biomes.NETHER_OLD_WORLD_DESERT;
+    }
+
+    private boolean isAshSurroundedByAsh(final @NotNull World world, final int ax, final int ay, final int az) {
+        return world.getBlockType(this.scratchEmberNeighbor.set(ax + 1, ay, az)) == Blocks.BLOCK_ASH
+            && world.getBlockType(this.scratchEmberNeighbor.set(ax - 1, ay, az)) == Blocks.BLOCK_ASH
+            && world.getBlockType(this.scratchEmberNeighbor.set(ax, ay, az + 1)) == Blocks.BLOCK_ASH
+            && world.getBlockType(this.scratchEmberNeighbor.set(ax, ay, az - 1)) == Blocks.BLOCK_ASH;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSoulCatcherPatch.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSoulCatcherPatch.java
index 4d9ab4857..17ec548f7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSoulCatcherPatch.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSoulCatcherPatch.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.generate.feature;
 
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
@@ -38,7 +39,12 @@ public class WorldFeatureSoulCatcherPatch implements WorldFeatureInterface {
             if (!world.isAirBlock(this.scratchQuery)) { continue; }
 
             this.scratchBelow.set(qx, qy - 1, qz);
-            final boolean overSoulSand = world.getBlockType(this.scratchBelow) == Blocks.SOULSAND;
+            Block<?> surface = world.getBlockType(this.scratchBelow);
+            final boolean overSoulSand = surface == Blocks.SOULSAND;
+
+            if (surface.equals(Blocks.OBSIDIAN)) {
+                continue;
+            }
 
             if (!overSoulSand && random.nextInt(SPORADIC_CHANCE_DENOM) != 0) {
                 continue;
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/ISaveFormat.java b/game/core/src/main/java/net/minecraft/core/world/save/ISaveFormat.java
index 2e34508b0..e0c043e4e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/ISaveFormat.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/ISaveFormat.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.save;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.Dimension;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.io.File;
 import java.util.List;
@@ -18,6 +19,14 @@ public interface ISaveFormat
      */
     String getFormatName();
 
+    /**
+     * Optional conversion subtitle text shown during world conversion.
+     * @return Message to show, or null to use default text.
+     */
+    default @Nullable String getFormatMessage() {
+        return null;
+    }
+
     /**
      * Returns the version associated with the save format.
      * @return The version associated with the save format.
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveConverters.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveConverters.java
index 5e483f259..63fa84e98 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveConverters.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveConverters.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.save;
 import net.minecraft.core.world.save.conversion.SaveConverter19132To19133;
 import net.minecraft.core.world.save.conversion.SaveConverter19133To19134;
 import net.minecraft.core.world.save.conversion.SaveConverter19134To19135;
+import net.minecraft.core.world.save.conversion.SaveConverter19135To19136;
 import net.minecraft.core.world.save.conversion.SaveConverterLegacyTo19132;
 
 import java.util.ArrayList;
@@ -20,5 +21,6 @@ public class SaveConverters
         saveConverters.add(new SaveConverter19132To19133());
         saveConverters.add(new SaveConverter19133To19134());
         saveConverters.add(new SaveConverter19134To19135());
+        saveConverters.add(new SaveConverter19135To19136());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
index 7660a31f3..814486e28 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
@@ -9,6 +9,7 @@ import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.Dimension;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.io.File;
@@ -33,6 +34,11 @@ public abstract class SaveFormatBase
         this.savesDir = savesDir;
     }
 
+    @Override
+    public @Nullable String getFormatMessage() {
+        return null;
+    }
+
     @Override
     public LevelData getLevelData(String worldDirName)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormats.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormats.java
index 4abda32e3..30474c051 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormats.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormats.java
@@ -8,11 +8,10 @@ import net.minecraft.core.world.save.mcregion.SaveFormat19132;
 import net.minecraft.core.world.save.mcregion.SaveFormat19133;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
 import net.minecraft.core.world.save.mcregion.SaveFormat19135;
+import net.minecraft.core.world.save.mcregion.SaveFormat19136;
 import org.slf4j.Logger;
 
 import java.io.File;
-import java.util.HashMap;
-import java.util.Map;
 
 public class SaveFormats
 {
@@ -37,5 +36,6 @@ public class SaveFormats
         saveFormats.put(19133, SaveFormat19133.class);
         saveFormats.put(19134, SaveFormat19134.class);
         saveFormats.put(19135, SaveFormat19135.class);
+        saveFormats.put(19136, SaveFormat19136.class);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/ItemConverters.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/ItemConverters.java
index b419ad579..6e18cf452 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/conversion/ItemConverters.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/ItemConverters.java
@@ -1,14 +1,17 @@
 package net.minecraft.core.world.save.conversion;
 
 import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.Tag;
 import net.minecraft.core.item.ItemBucket;
 import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.NotNull;
 
 public class ItemConverters {
     /**
      * Migrates legacy bucket IDs to the new NBT-based Bucket system.
      */
-    public static void legacyBucketConverter(CompoundTag tag) {
+    public static void legacyBucketConverter(@NotNull CompoundTag tag) {
         short id = tag.getShort("id");
         NamespaceID newState = null;
 
@@ -41,4 +44,29 @@ public class ItemConverters {
             tag.putCompound("Data", dataTag);
         }
     }
-}
\ No newline at end of file
+
+    /**
+     * Recursively migrates legacy bucket item ids in any nested NBT tag tree.
+     */
+    public static void legacyBucketConverterRecursive(CompoundTag tag) {
+        legacyBucketConverter(tag);
+
+        for (final Tag<?> childTag : tag.getValues()) {
+            if (childTag instanceof CompoundTag childCompound) {
+                legacyBucketConverterRecursive(childCompound);
+            } else if (childTag instanceof ListTag childList) {
+                legacyBucketConverterRecursive(childList);
+            }
+        }
+    }
+
+    private static void legacyBucketConverterRecursive(@NotNull ListTag listTag) {
+        for (final Tag<?> listEntry : listTag) {
+            if (listEntry instanceof CompoundTag childCompound) {
+                legacyBucketConverterRecursive(childCompound);
+            } else if (listEntry instanceof ListTag childList) {
+                legacyBucketConverterRecursive(childList);
+            }
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19134To19135.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19134To19135.java
index 6ef88d731..6cc279245 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19134To19135.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19134To19135.java
@@ -21,6 +21,7 @@ import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.Random;
 
+//Legacy Nether Conversion (8.0)
 public class SaveConverter19134To19135 extends SaveConverterMCRegionBase{
     private static final Logger LOGGER = LogUtils.getLogger();
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19135To19136.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19135To19136.java
new file mode 100644
index 000000000..a4b00e865
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19135To19136.java
@@ -0,0 +1,136 @@
+package net.minecraft.core.world.save.conversion;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.NbtIo;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.ProgressListener;
+import net.minecraft.core.world.save.mcregion.RegionFile;
+import net.minecraft.core.world.save.mcregion.RegionFileCache;
+import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.File;
+import java.io.IOException;
+import java.nio.file.Files;
+import java.util.ArrayList;
+import java.util.Collections;
+
+
+//Legacy Bucket Conversion (8.0)
+public class SaveConverter19135To19136 extends SaveConverterMCRegionBase {
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    @Override
+    public int fromVersion() {
+        return 19135;
+    }
+
+    @Override
+    public int toVersion() {
+        return 19136;
+    }
+
+    @Override
+    public void convertSave(@NotNull CompoundTag levelData, @NotNull File savesDir, @NotNull String worldDirName, @NotNull ProgressListener progress) {
+        convertBasketTileEntities(levelData);
+        ItemConverters.legacyBucketConverterRecursive(levelData);
+        convertPlayerDataFiles(savesDir, worldDirName);
+        super.convertSave(levelData, savesDir, worldDirName, progress);
+    }
+
+    @Override
+    int convertDimensionRegions(@NotNull Dimension dimension, @NotNull ArrayList<File> regionFiles, int conversionsPerformed, int totalConversions, @NotNull ProgressListener progress) {
+        Collections.sort(regionFiles);
+        int progressValue = 0;
+        int conversions = 0;
+
+        for (File region : regionFiles) {
+            progress.progressStagePercentage(progressValue);
+
+            RegionFile regionFile = new RegionFile(region);
+
+            for (int x = 0; x < 32; x++) {
+                for (int z = 0; z < 32; z++) {
+                    try {
+                        DataInputStream inputStream = regionFile.getChunkDataInputStream(x, z);
+                        if (inputStream == null) continue;
+                        DataOutputStream outputStream = regionFile.getChunkDataOutputStream(x, z);
+                        CompoundTag chunkData = NbtIo.read(inputStream);
+
+                        convertBasketTileEntities(chunkData);
+                        ItemConverters.legacyBucketConverterRecursive(chunkData);
+                        NbtIo.write(chunkData, outputStream);
+
+                        inputStream.close();
+                        outputStream.close();
+                    } catch (IOException e) {
+                        LOGGER.error("Failed to convert chunk X:{}, Z:{}, in region {}!", x, z, region.toPath(), e);
+                    }
+                }
+            }
+
+            conversions++;
+            progressValue = (int) Math.round((100D * (double) (conversionsPerformed + conversions)) / (double) totalConversions);
+        }
+
+        RegionFileCache.flushCache();
+
+        return conversions;
+    }
+
+    private static void convertBasketTileEntities(@NotNull CompoundTag rootTag) {
+        CompoundTag levelTag = rootTag.getCompoundOrDefault("Level", null);
+        if (levelTag == null) {
+            return;
+        }
+
+        ListTag tileEntities = levelTag.getListOrDefault("TileEntities", null);
+        if (tileEntities == null) {
+            return;
+        }
+
+        for (Tag<?> tag : tileEntities) {
+            if (!(tag instanceof CompoundTag tileEntityTag)) {
+                continue;
+            }
+            String id = tileEntityTag.getString("id");
+            if (!"minecraft:basket".equals(id) && !"Basket".equals(id)) {
+                continue;
+            }
+
+            ListTag itemsTag = tileEntityTag.getListOrDefault("Items", null);
+            if (itemsTag == null) {
+                continue;
+            }
+
+            for (Tag<?> itemTag : itemsTag) {
+                if (itemTag instanceof CompoundTag itemCompound) {
+                    ItemConverters.legacyBucketConverter(itemCompound);
+                }
+            }
+        }
+    }
+
+    private void convertPlayerDataFiles(@NotNull File savesDir, @NotNull String worldDirName) {
+        File playersDir = new File(new File(savesDir, worldDirName), "players");
+        File[] playerFiles = playersDir.listFiles((dir, name) -> name.endsWith(".dat"));
+        if (playerFiles == null) {
+            return;
+        }
+
+        for (File playerFile : playerFiles) {
+            try {
+                CompoundTag playerData = NbtIo.readCompressed(Files.newInputStream(playerFile.toPath()));
+                ItemConverters.legacyBucketConverterRecursive(playerData);
+                NbtIo.writeCompressed(playerData, Files.newOutputStream(playerFile.toPath()));
+            } catch (IOException e) {
+                LOGGER.error("Failed to convert player data file '{}' for world '{}'!", playerFile.getName(), worldDirName, e);
+            }
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19135.java b/game/core/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19135.java
index 9ded2b877..7421fa599 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19135.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19135.java
@@ -15,6 +15,9 @@ public class SaveFormat19135 extends SaveFormatBase {
         return "BTARegion";
     }
 
+    @Override
+    public String getFormatMessage(){ return "Converting Legacy Nether...";}
+
     @Override
     public int getSaveVersion() {
         return 19135;
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19136.java b/game/core/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19136.java
new file mode 100644
index 000000000..cc9dd93fb
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19136.java
@@ -0,0 +1,39 @@
+package net.minecraft.core.world.save.mcregion;
+
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.SaveFormatBase;
+
+import java.io.File;
+
+public class SaveFormat19136 extends SaveFormatBase {
+    public SaveFormat19136(File savesDir) {
+        super(savesDir);
+    }
+
+    @Override
+    public String getFormatName() {
+        return "BTARegion";
+    }
+
+    @Override
+    public String getFormatMessage(){ return "Converting Legacy Buckets...";}
+
+    @Override
+    public int getSaveVersion() {
+        return 19136;
+    }
+
+    @Override
+    public void flushCache() {
+        RegionFileCache.flushCache();
+    }
+
+    @Override
+    public File getDimensionRootDir(String worldDirName, Dimension dimension) {
+        File worldDir = new File(savesDir, worldDirName);
+
+        File worldDimsDir = new File(worldDir, "dimensions");
+
+        return new File(worldDimsDir, Integer.toString(dimension.id));
+    }
+}
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
index a2406e4fa..f7521cce3 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
@@ -308,6 +308,10 @@ gui.options.hudeditor.onboarding.reset=Press '%1$s' to reset layout to default
 gui.options.hudeditor.onboarding.exit=Press '%1$s' to leave the HUD Editor
 gui.options.hudeditor.onboarding.reopen=Press '%1$s' to see this screen again!
 gui.options.hudeditor.onboarding.begin=Click anywhere to begin
+gui.options.hudeditor.snap_to_fill=Snap To Fill
+gui.options.hudeditor.scale=GUI Scale
+gui.options.hudeditor.chat_width=Chat Width
+gui.options.hudeditor.chat_height=Chat Height
 
 gui.sound_test.label.title=Sound Test
 gui.sound_test.label.repo=Sound Repository: %s
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang
index fe9875735..684c26c67 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang
@@ -6,8 +6,8 @@ item.tool.pickaxe.iron.name=Iron Pickaxe
 item.tool.pickaxe.iron.desc=Pick some stone with this iron tool.
 item.tool.axe.iron.name=Iron Axe
 item.tool.axe.iron.desc=Chop some trees with this iron tool.
-item.tool.firestriker.name=Fire Striker
-item.tool.firestriker.desc=Don't even think about it.
+item.tool.firestriker.iron.name=Fire Striker
+item.tool.firestriker.iron.desc=Don't even think about it.
 item.tool.firestriker.steel.name=Steel Fire Striker
 item.tool.firestriker.steel.desc=Even more dangerous.
 item.food.apple.name=Apple
@@ -505,8 +505,8 @@ item.statue.pigman.desc=An ancient marble statue found in a long-forgotten place
 item.dough.name=Dough
 item.dough.desc=Uncooked dough. Can be baked into bread.
 
-item.rubyglass.name=Rubyglass
-item.rubyglass.desc=A shard of charged rubyglass, brimming with energy.
+item.rubyglass.crystal.name=Rubyglass
+item.rubyglass.crystal.desc=A shard of charged rubyglass, brimming with energy.
 
 item.armor.wolf.leather.name=Leather Wolf Armor
 item.armor.wolf.leather.desc=Keep your best friend safe with this soft leather shell.
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
index cc2ed3fb2..bf8544bbf 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
@@ -42,11 +42,14 @@ options.fancyGraphics=Graphics
 options.connectedGlass=Connected Glass
 options.graphics.fancy=Fancy
 options.graphics.fast=Fast
-options.guiScale=GUI Scale
+options.guiScale=Global GUI Scale
 options.guiScale.auto=Auto
+options.guiScale.disabled=Disabled
 options.guiScale.small=Small
 options.guiScale.normal=Normal
 options.guiScale.large=Large
+options.guiScaleOverride=GUI Scale Override
+options.guiScaleOverride.disabled=Disabled
 options.advancedOpengl=Advanced OpenGL
 options.treeShadows=Leaf Shadowing
 options.transparencyDepthCheck=Translucent Depth Check
@@ -324,6 +327,15 @@ options.horizontalLogTextAlignment.left=Left
 options.horizontalLogTextAlignment.center=Center
 options.horizontalLogTextAlignment.right=Right
 
+options.horizontalChatTextAlignment=Horizontal Alignment
+options.horizontalChatTextAlignment.left=Left
+options.horizontalChatTextAlignment.center=Center
+options.horizontalChatTextAlignment.right=Right
+options.horizontalSubtitleTextAlignment=Horizontal Alignment
+options.horizontalSubtitleTextAlignment.left=Left
+options.horizontalSubtitleTextAlignment.center=Center
+options.horizontalSubtitleTextAlignment.right=Right
+
 options.verticalInfoTextAlignment=Vertical Alignment
 options.verticalInfoTextAlignment.top=Top
 options.verticalInfoTextAlignment.center=Center
@@ -334,6 +346,15 @@ options.verticalLogTextAlignment.top=Top
 options.verticalLogTextAlignment.center=Center
 options.verticalLogTextAlignment.bottom=Bottom
 
+options.verticalChatTextAlignment=Vertical Alignment
+options.verticalChatTextAlignment.top=Top
+options.verticalChatTextAlignment.center=Center
+options.verticalChatTextAlignment.bottom=Bottom
+options.verticalSubtitleTextAlignment=Vertical Alignment
+options.verticalSubtitleTextAlignment.top=Top
+options.verticalSubtitleTextAlignment.center=Center
+options.verticalSubtitleTextAlignment.bottom=Bottom
+
 key.attack=Attack
 key.interact=Interact
 key.pickBlock=Pick Block
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/subtitles.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/subtitles.lang
index a61904b28..a71e37e33 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/subtitles.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/subtitles.lang
@@ -107,6 +107,16 @@ subtitles.tile.dispenser.fire=Dispenser fire
 subtitles.tile.activator.click=Activator click
 subtitles.tile.activator.use=Activator use
 
+subtitles.tile.crystal=Crystal tinkle
+
+subtitles.tile.scrape=Statue scraping
+
+subtitles.tile.deepcrumble=Deep crumble
+subtitles.tile.deepboom=Deep boom
+subtitles.tile.crumble=Crumble
+subtitles.tile.acidbubble=Acid bubble
+subtitles.tile.deepquietboom=Deep quiet boom
+
 subtitles.hurt.flesh=Hurt flesh
 
 subtitles.fire.ignite=Fire lit
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
index 4b50a3e00..a41e92957 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
@@ -296,6 +296,8 @@ tile.slab.basalt.carved.name=Polished Basalt Slab
 tile.slab.basalt.carved.desc=A slab of polished basalt.
 tile.slab.permafrost.carved.name=Polished Permafrost Slab
 tile.slab.permafrost.carved.desc=A slab of polished permafrost.
+tile.slab.slate.carved.name=Polished Slate Slab
+tile.slab.slate.carved.desc=A slab of polished slate.
 
 tile.slab.planks.oak.painted.name=Mystery Wooden Slab
 tile.slab.planks.oak.painted.desc=How did you get this?!
@@ -865,14 +867,20 @@ tile.piston.base.name=Piston
 tile.piston.base.desc=Pushes blocks but does not pull them.
 tile.piston.base.sticky.name=Sticky Piston
 tile.piston.base.sticky.desc=Pushes and pulls blocks.
-tile.piston.head.name=Piston Head
-tile.piston.head.desc=The pushy part of the piston.
-tile.piston.moving.name=Piston Mover
-tile.piston.moving.desc=The invisible moving part of the piston.
 tile.piston.base.steel.name=Reinforced Piston
 tile.piston.base.steel.desc=Pushes blocks and entities with immense force.
+tile.piston.base.detached.name=Detached Piston
+tile.piston.base.detached.desc=Emotionally unavailable.
+tile.piston.base.sticky.detached.name=Detached Sticky Piston
+tile.piston.base.sticky.detached.desc=Emotionally unavailable and covered in slime.
+tile.piston.base.steel.detached.name=Detached Reinforced Piston
+tile.piston.base.steel.detached.desc=Emotionally unavailable, but made of steel.
+tile.piston.head.name=Piston Head
+tile.piston.head.desc=The pushy part of the piston.
 tile.piston.head.steel.name=Reinforced Piston Head
 tile.piston.head.steel.desc=The pushy part of the steel piston.
+tile.piston.moving.name=Piston Mover
+tile.piston.moving.desc=The invisible moving part of the piston.
 
 tile.noteblock.name=Note Block
 tile.noteblock.desc=Plays a musical note when powered.
